#ifndef __COMMON_H__
#define __COMMON_H__

#ifdef __FreeBSD__
#include <sys/consio.h>
#else
#include <sys/vt.h>
#endif

#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

#include <ctype.h>
#include <regex.h>
#include <fstream.h>
#include <strstream>
#include <locale.h>
#include <libintl.h>
#include <fcntl.h>
#include <pwd.h>
#include <signal.h>

#include <list>
#include <algorithm>

#include "parser.h"

#include "konst.string.h"
#include "konst.list.h"
#include "konst.process.h"
#include "konst.ui.tree.h"
#include "konst.ui.horbar.h"
#include "konst.ui.edit.h"
#include "konst.ui.input.h"
#include "konst.ui.text.h"
#include "konst.ui.dlg.h"

#define _(s) gettext(s)
#define stryesno(b) (b ? _("yes") : _("no"))

#define DIST_SCRIPT_NAME  "Dist.motor"
#define MAKEFILE_NAME     "Makefile.motor"

#define CA_DONTSHOW             2
#define CA_DONTASK		4

#define ANSWER_YES		0
#define ANSWER_NO		1
#define ANSWER_CANCEL		2
#define ANSWER_ALL              3

#define DIALOG_WIDTH	(int) (COLS*0.85)
#define DIALOG_HEIGHT	(int) (LINES*0.75)

#define M_LINK			false
#define M_COMPILE		true

#define cp_input		37
#define cp_bottom		39
#define cp_bottomhl		40
#define cp_menu			43
#define cp_menusel		44
#define cp_menuhl 		45
#define cp_menufr		46
#define cp_debug_current	48
#define cp_debug_breakpoint	49

#ifndef VERSION
#define VERSION "0.0"
#endif

#ifndef SHAREDIR
#define SHAREDIR "/usr/local/share"
#endif

#ifndef MAKECMD
#define MAKECMD "make"
#endif

#endif
