#ifndef __COMPILE_H__
#define __COMPILE_H__

#include <sys/wait.h>

#include "konst.ui.menu.h"

#include "common.h"
#include "project.h"

class compilermessage {
    public:
    int line;
    string fname, text;
};

class CMotorCompiler {
    private:
        FILE *fpipe;
	int current;
	vector<compilermessage> messages;
        verticalmenu resultsm;

        static int resultkeys(verticalmenu *ref, int k);
        static void freeparseregex(void *r);

	bool readpipe();
	
    public:
        int nwarn, nerr, nfiles;
        
	CMotorCompiler();
	~CMotorCompiler();

        string makename(motorproject *pr, makenamemode mm);
        bool runmake(makenamemode mm, string target);

	void show();
        void select(int n);
	void output();
        void quickmove(int delta);
};

extern CMotorCompiler cmp;

#endif
