#ifndef __CONF_H__
#define __CONF_H__

#include "common.h"

class externalkey {
    private:
        int keycode;
        string keyname, commandline, comment;
        
    public:
        externalkey(string defline);
        ~externalkey();
        
        bool thekey(int code);
        void execute();
        void setcomment(string cmnt);
        void tomenu(verticalmenu *m);
};

class externalkeylist: public linkedlist {
    private:
    public:
        externalkey *get(int n);
        
        void showlist();
        void execkey(int code);
};

class CMotorConfig {
    private:
        horizontalbar *cbar;
        string schemename;

        vector<int> boldcolors;
        vector<string> repositories;

        void gensettings(treeview *tree);
        
        static int listkeys(verticalmenu *m, int k);

    public:
        bool autocvsupdate, autocvscommit;
        externalkeylist extkeys;
        
	CMotorConfig();
	~CMotorConfig();

        int findcolor(string s);
        
	void check();
	void read();
	void write();

        void readthemes();
        int getcolor(int paircode);
        string getschemename();

        void commandline(int argc, char *argv[]);

        void addcvs();
        void execute();

        int getreposcount();
        string getrepos(int n);
};

bool getconf(string &sect, string &buf, ifstream &f);

extern CMotorConfig conf;

#endif
