#ifndef __DEBUGP_H__
#define __DEBUGP_H__

#include "common.h"

class breakpoint { public:
    int line, id;
    bool permanent;
    string fname;

    breakpoint();
    breakpoint(const string afname, int aline, bool apermanent = true);
    ~breakpoint();

    bool operator == (const breakpoint &abp) const;
    bool operator != (const breakpoint &abp) const;

    bool operator == (const int &aid) const;
    bool operator != (const int &aid) const;

    bool operator == (const bool &aperm) const;
    bool operator != (const bool &aperm) const;
};

class watchexpr { public:
    string name, val;

    watchexpr();
    watchexpr(const string aname, const string aval = "");
    ~watchexpr();
};

enum dpkind {dpwatch, dpbreakpoint};

class debugpoint {
    protected:
        dpkind kind;
        breakpoint breakp;
        watchexpr watch;

    public:
        debugpoint(dpkind, string text);
        ~debugpoint();

        dpkind getkind();
        watchexpr getwatch();
        breakpoint getbreakpoint();

        void todebugger();
};

class progstackitem {
    protected:
        string fname, funcname, funcargs;
        int lineno;
        
    public:
        progstackitem(string line);
        ~progstackitem();

        void nextline(string line);

        string getfname() const;
        string getfunction() const;
        string getargs() const;
        int getline() const;
};

#endif

