#ifndef __EDIT_H__
#define __EDIT_H__

#include "common.h"

// Search directions

#define SD_FORWARD      true
#define SD_BACKWARD     false

enum teditoperation {
    edcut,
    edcopy,
    edpaste
};

enum edlayout {
    elwatch,
    elnormal
};

class syntaxhl {
    public:
	string mask, tag;
        int scheme;
};

class confcolorpair {
    public:
	int id, pair;
	bool bold;
};

class motoreditor {
    protected:
	texteditor e;
        linkedlist syntax;
        string findsub;
        horizontalbar *bar;

        int getsyntax(string fname);
        void readsyntax();

        static int editkeys(texteditor *ref, int k);
        static void editidle(texteditor *ref);
        static void *guessfname(void *ppf, void *sfname);

    public:
	motoreditor();
	~motoreditor();

	void init();
	void redraw();

        void updatecursor();
        void switchmark();
        void switchins();
        void shift(bool dir);
        void undo();
        void status();
        void status(int x, int y, bool imode, bool bmode);
        int open();

	void saveas();
	void save();
	void saveall(bool askf = false);

        bool openfile(string fname, int posline = 0, bool create = false);
	void load();
	void switchwindow(int delta);
	void editload();
	bool editclose(int options);
	bool closewindow(int options);
	void gotoline();
        void editoperation(teditoperation ed);
        bool modified();
	void findtext(bool next);
	void replace();

        void markbreakpoints();
        void enlight(int fnum, int line, int clr);
        void unlight(int fn, int prevline);
        void getpos(int *col, int *line);
        int getpos();
        void resize(edlayout l);

        void windowlist();

	string clipfname();
        string getcurrentfname();
        string atcursor();
        
        int getcurrentfnum();
};

extern motoreditor ed;

#endif
