#ifndef __GREP_H__
#define __GREP_H__

#include "common.h"
#include "project.h"

enum grepmode {gmcurrent, gmfolders, gmall, gmconnected};
enum maskmode {maregex, masub};

class grepresult { public:
    string fname;
    unsigned int line;
};

class motorgrepper {
    protected:
        textwindow *w;
        horizontalbar *bar;
        treeview *tree;
        bool initial, casesens, genfirst;
        string mask;
        grepmode mode;
        maskmode mmode;
        int listpos;

        vector<grepresult> results;
        vector<int> exclfold;

        static int listkeys(verticalmenu *m, int k);

        const char *strgrepmode(grepmode m);
        const char *strmaskmode(maskmode m);

        void initbar();
        void gentree();
	void perform();
        void showprogress(string fname);

        bool grepfile(string fname);
        bool grepconnected(motorproject *pr);
        bool grepfolder(filefolder *fold);
        
    public:
        motorgrepper();
        ~motorgrepper();

        void exec();
        void nextresult();
};

extern motorgrepper grep;

#endif

