#ifndef __MANAGER_H__
#define __MANAGER_H__

#include "common.h"
#include "project.h"

class CMotorManager {
    protected:
        horizontalbar *cbar;
        treeview *ctree;

        void removefile(projectfile *p);
        bool viewconnected(motorproject *mp);

        void changetemplate();
        void changesetting(string *param, string prompt, bool emptyallowed);
        void gensettings(treeview *tree);
        
        void gensourcetree(treeview *tree, bool dirs);
        bool projectfiles(bool dirs);
        bool performcreate(screateinfo *info);
        void performaddfile(string fname, filefolder *dest, motorproject *source, bool add);
        void performtakes(motorproject *mp, filefolder *fold, bool add);
        
        bool create();
	bool closeprev(int options = 0);
        bool checkopen(motorproject *pr);

    public:
	CMotorManager();
	~CMotorManager();

        void list();
        void generatefiles(bool all = true);

        bool files();
        bool dirs();
        
        bool settings();
        bool addfile(filefolder *fold);
};

extern CMotorManager mgr;

#endif
