#ifndef __TAGBROWSER_H__
#define __TAGBROWSER_H__

#include "common.h"

class tagitem {
    protected:
        string name, fname, info;
        char kind;
        int lineno;

    public:
        tagitem(string buf);
        ~tagitem();
        
        string getname();
        string getfname();
        string getinfo();
        char getkind();
        int getlineno();
};

class tagbrowser {
    protected:
        enum e_listmode {lminfo, lmfname} listmode;

        string search;
        int x1, x2, y1, y2, ncolor, wcolor, scolor, hcolor, woptions;
        bool modified;

        vector<tagitem> tags;
        textwindow *w;

        bool checktags(string fname);
        void parseline(string buf);
        void makemenu(verticalmenu *m);
        void input();

        string gettagname(char kind);

        static int mkeys(verticalmenu *m, int k);

    public:
        tagbrowser();
        ~tagbrowser();

        void set(int nx1, int ny1, int nx2, int ny2, int nwcolor, int nncolor, int nscolor, int nhcolor, int nwoptions);
        void read(string fname);
        bool open(string &fname, int &lineno);

        void setsearch(string nsearch);
        string getsearch();

        void exec(string s = "");
        void cleanup(string pname);
};

extern tagbrowser browser;

#endif
