#ifndef __MOTOR_TEMPLATE_H_
#define __MOTOR_TEMPLATE_H_

#include "common.h"
#include "folder.h"
#include "distmethod.h"

class parserule {
    public:
    string mask;
    int nfname, nline, ndescr;
    bool iserror;
};

class buildrule {
    public:
    string fname, compile;
    linkedlist *parse;
};

class motortemplate {
    protected:
	string makefile, name, resultrule, home, etagscmd;
	linkedlist folders, buildrules, dists, ftempls, tagnames;

        static int findbuildrule(void *fname, void *rule);
        static int findfolderbyname(void *fname, void *folder);
        static int readfiletemplatesftw(const char *file, const struct stat *sb, int flag);
        
        void addfolder(filefolder *fold, linkedlist &collect);

        void readbuildrules();
        void readfolders();
        void readmakefile();
        void readdistmethods();
        void readfiletemplates();
        void readsyntax();
        
    public:
	motortemplate();
	~motortemplate();

        int getfoldercount();
        int getdistcount();
        int getftemplcount();

        distmethod *getdist(int n);
        string getftempl(int n);
        filefolder *getfolder(string name);
        filefolder *getfolder(int n);

        buildrule *getbuildrule(string fname);
	void load(string templname);
        string select();

        string getname();
        string gethome();
        string getresultrule();
        string getetagscmd();
        string gettagname(char kind);

        void writemakefile(pparamslist *params, FILE *f);
};

#endif
