/*
* parser_cgi.h - Parser extension for CGI programs
*
* Authors:	RomaRoma (http://www.rr.org.ua/)
*
* Created:	06.03.2000	romaroma	Initial revision.
* Changed:	20.06.2000	romaroma	New svalue tags
*
*/

/*
Process this keys in "svalue" tag:
    mime - encode string to MIME format
    js - encode string for JavaScript usage
    nobr - replace all spaces to "&nobr;"
    noquot - replace all quotes to spaces
    nohtml - replace all special HTML characters to it's HTML equivalents
*/

#ifndef _PARSER_CGI_H
#define _PARSER_CGI_H

#ifdef __cplusplus
extern "C" {
#endif 

/*****************************************************************************/
/* External parser procedure registration */
/*****************************************************************************/

/*
* parser_cgi_init - Initialize module
* parser_cgi_done - Deinitialize module
* 
* Parameters:
*	none
*
* Return value:
* 	none
*/
void parser_cgi_init();
void parser_cgi_done();

#ifdef __cplusplus
}
#endif 

#endif
 /* _PARSER_CGI_H
 */
