/*
* parser_cgi.c - Parser extension for CGI programs
*/

#include <string.h>

#include <strfn.h>
#include <parser_cgi.h>
#include <parser.h>

/*****************************************************************************/
/* External parser procedure */
/*****************************************************************************/

char *prs_cgi_svalue_proc(const char *value, const char *key) {
    if (!key || !key[0]) return 0;
    
    if (!strcasecmp(key, "mime")) {
	return get_mime_text(value);
    }
    else if (!strcasecmp(key, "js")) {
	return get_js_text(value);
    }
    else if (!strcasecmp(key, "nobr")) {
	return get_nobr_text(value);
    }
    else if (!strcasecmp(key, "noquot")) {
	return get_noquot_text(value);
    }
    else if (!strcasecmp(key, "nohtml")) {
	return get_nohtml_text(value);
    }
    else if (!strcasecmp(key, "nohtml_br")) {
	return get_nohtml_br_text(value);
    }
    else if (!strcasecmp(key, "html")) {
	return get_html_text(value);
    }
    
    return 0;
}


/*****************************************************************************/
/* External parser procedure registration */
/*****************************************************************************/

/*
* parser_cgi_init
*/
void parser_cgi_init() {
//parser_svalue_proc *proc
    parser_svalue_reg(&prs_cgi_svalue_proc);
}

/*
* parser_cgi_done
*/
void parser_cgi_done() {
    parser_svalue_unreg(&prs_cgi_svalue_proc);
}
