#include "distmethod.h"
#include "project.h"
#include "edit.h"

distmethod::distmethod(string nname, FILE *f) {
    struct stat sb;
    name = nname;
    
    if(f) {
        fstat(fileno(f), &sb);
        char *buf = new char[sb.st_size+1];
        fread(buf, sb.st_size, 1, f);
        buf[sb.st_size] = 0;
        ptemplate = buf;
        delete buf;
    }
}

distmethod::~distmethod() {
}

string distmethod::getname() {
    return name;
}

void distmethod::write() {
    FILE *f;
    string distname = (string) proj->rootdir + "/" + DIST_SCRIPT_NAME;

    if(proj->pconnected) proj->genconnectedmakefiles(mmdist);
    proj->genmakefile(mmdist);

    if(f = fopen(distname.c_str(), "w")) {
        pparamslist *params = pparamslist_create();
        proj->populateparselist(params);
        chdir(proj->tmpl->gethome().c_str());
        fstrparse(ptemplate.c_str(), params, f);
        proj->chdir();
        pparamslist_free(params);
        fclose(f);
    }
}

void distmethod::generate() {
    proj->save();
    proj->chdir();
    ed.editclose(CA_DONTSHOW | CA_DONTASK);

    endwin();
    attrset(color(0));
    for(int i = 0; i < LINES; i++, printf("\n\n"));
    printf(_("+ generating a distribution package\n"));
    fflush(stdout);

    string cline = (string) ". " + DIST_SCRIPT_NAME + " 2>&1";
    system(cline.c_str());
    
    proj->chdir();
    unlink(DIST_SCRIPT_NAME);

    printf(_("+ done. press enter."));
    fflush(stdout);
    getkey();
    ed.editload();
    ed.redraw();

    if(proj->leavemakef) proj->genmakefile();
    proj->genconnectedmakefiles();
}
