#include "folder.h"

filefolder::filefolder():
elem(fefile) {
    takes = new linkedlist;
    takes->freeitem = &charpointerfree;
    
    regcomp(&r, "^$", REG_EXTENDED);
    regcomp(&rejectr, "^$", REG_EXTENDED);
}

filefolder::~filefolder() {
    delete takes;
    
    regfree(&r);
    regfree(&rejectr);
}

void filefolder::setname(string nname) {
    name = nname;
}

void filefolder::setshortname(string nname) {
    shortname = nname;
}

void filefolder::setmask(string nmask) {
    regfree(&r);
    regcomp(&r, nmask.c_str(), REG_EXTENDED);
}

void filefolder::setreject(string nreject) {
    regfree(&rejectr);
    regcomp(&rejectr, nreject.c_str(), REG_EXTENDED);
}

void filefolder::setelem(folderelement nelem) {
    elem = nelem;
}

bool filefolder::accepts(string fname) {
    return
       !regexec(&r, fname.c_str(), 0, 0, 0) &&
       regexec(&rejectr, fname.c_str(), 0, 0, 0);
}

string filefolder::getname() {
    return name;
}

string filefolder::getshortname() {
    return shortname;
}

folderelement filefolder::getelem() {
    return elem;
}

int filefolder::gettakecount() {
    return takes->count;
}

void filefolder::addtake(string ntake) {
    takes->add(strdup(ntake.c_str()));
}

string filefolder::gettake(int n) {
    return (const char *) takes->at(n);
}
