#include "plist.h"
#include "cvs.h"
#include "conf.h"

CMotorProjectList::CMotorProjectList() {
}

CMotorProjectList::~CMotorProjectList() {
}

int CMotorProjectList::findprojectbyname(void *name, void *proj) {
    return (string) ((char *) name) != ((motorproject *) proj)->name;
}

motorproject *CMotorProjectList::get(string name) {
    return (motorproject *) find((void *) name.c_str(), &findprojectbyname);
}

motorproject *CMotorProjectList::get(int n) {
    return (motorproject *) at(n);
}

int CMotorProjectList::load() {
    DIR *d;
    struct dirent *ent;
    struct stat sb;
    string fname, pname = (string) getenv("HOME") + "/.motor/projects/";

    if(d = opendir(pname.c_str())) {
        while(ent = readdir(d)) {
            fname = pname + ent->d_name;
            
            if(!stat(fname.c_str(), &sb) && S_ISREG(sb.st_mode)) {
                if(!access(fname.c_str(), F_OK)) {
                    motorproject *mp = new motorproject;
                    mp->loadfromfile(fname);
                    mp->name = ent->d_name;
                    if(!mp->rootdir.empty()) add(mp); else delete mp;
                }
            }
        }
        closedir(d);
        return 0;
    } else {
        return -1;
    }
}

bool CMotorProjectList::setcur(string fname) {
    if(proj = get(fname.c_str())) {
        cvs.setrepos(proj->cvsroot);
        proj->putdebug();
        return true;
    }

    return false;
}

void CMotorProjectList::create(string fname, string root, motortemplate *t) {
    motorproject *p = new motorproject;
    p->tmpl = t;
    p->name = fname;
    p->rootdir = root;
    
    if(!t->getresultrule().empty()) {
        pparamslist *params = pparamslist_create();
        p->populateparselist(params);
        p->result = strim(sstrparse(t->getresultrule().c_str(), params));
        pparamslist_free(params);
    }

    if(p->result.empty()) p->result = fname;
    if(p->version.empty()) p->version = "0.1";
    if(p->packgendir.empty()) p->packgendir = p->rootdir;
    if(p->outdir.empty()) p->outdir = p->rootdir;

    add(p);
}

motorproject *CMotorProjectList::select(filefolder *toput = 0) {
    int i, k, pc;
    bool proceed;
    motorproject *p, *ret = 0;
    dialogbox db;

    db.setwindow(new textwindow(0, 0, DIALOG_WIDTH, DIALOG_HEIGHT,
        conf.getcolor(cp_menufr), TW_CENTERED,
        conf.getcolor(cp_menuhl), _(" Select a project ")));

    db.setmenu(new verticalmenu(conf.getcolor(cp_menu), conf.getcolor(cp_menusel)));

    for(i = 0; i < count; i++) {
        p = get(i);
        proceed = true;
        if(toput) proceed = toput->accepts(p->tmpl->getname());
        if(proceed) db.getmenu()->additemf(" %s", p->name.c_str());
    }

    if(db.open(k, i))
    for(i = pc = 0; i < count; i++) {
        p = get(i);
        proceed = true;
        if(toput) proceed = toput->accepts(p->tmpl->getname());
        if(proceed && (++pc == k)) {
            ret = p;
            break;
        }
    }
    
    db.close();
    return ret;
}

