#include "progress.h"
#include "conf.h"

CMotorProgress::CMotorProgress(const char *title): line(0), col(0), isopen(false) {
    w.setcoords(0, 0, DIALOG_WIDTH, DIALOG_HEIGHT);
    w.setcolor(conf.getcolor(cp_menufr));
    w.setoptions(TW_CENTERED);
    w.set_title(conf.getcolor(cp_menuhl), "%s", title);
}

CMotorProgress::~CMotorProgress() {
    if(isopen) w.close();
}

void CMotorProgress::print(bool newline, progressprintmode mode, string st) {
    int color;

    if(!isopen) {
        w.open();
        isopen = true;
    }

    switch(mode) {
        case pmheader: color = conf.getcolor(cp_menuhl); break;
        case pminfo: color = conf.getcolor(cp_menu); break;
    }

    if(newline)
    if(++line >= DIALOG_HEIGHT) {
        w.redraw();
        line = 1;
        col = 0;
    }
    
    w.write(col+1, line, color, st);
}

