#include "tlist.h"
#include "conf.h"

CMotorTemplateList::CMotorTemplateList() {
}

CMotorTemplateList::~CMotorTemplateList() {
}

int CMotorTemplateList::loadftw(const char *file, const struct stat *sb, int flag) {
    if(flag == FTW_F) {
        int pos;
        motortemplate *t;
        string tname = file;
        
        if(pos = tname.find("/templates/")) {
            tname.replace(0, pos+11, "");
	    getrword(tname, "/");
	    tname = trailcut(leadcut(tname, "/"), "/");

            if(!tlist.get(tname.c_str())) {
                t = new motortemplate;
	        t->load(tname.c_str());
	        tlist.add(t);
            }
        }
    }
    
    return 0;
}

void CMotorTemplateList::load() {
    string tdir = (string) getenv("HOME") + "/.motor/templates/";
    if(access(tdir.c_str(), F_OK)) tdir = (string) SHAREDIR + "/motor/templates/";

    ftw(tdir.c_str(), &loadftw, 5);
}

motortemplate *CMotorTemplateList::get(string tname) {
    return (motortemplate *) find((void *) tname.c_str(), &findtemplatebyname);
}

motortemplate *CMotorTemplateList::get(int n) {
    return (motortemplate *) at(n);
}

int CMotorTemplateList::findtemplatebyname(void *name, void *templ) {
    return (string) ((const char *) name) != ((motortemplate *) templ)->getname();
}

void CMotorTemplateList::genselectlist(treeview *tree,
regex_t *regex = 0, int foldid = 0, const char *p = 0, int offset = 0,
motortemplate *ctemplate = 0) {
    int i, nfid;
    const char *r, *nextlevel;
    motortemplate *t;
    char buf[512], sub[512];

    linkedlist processed;
    processed.freeitem = &charpointerfree;

    if(!p) {
        for(i = 0; i < count; i++) {
            t = get(i);
            if(!processed.find(kgetword(1, t->getname().c_str(), "/", buf, 512), &stringcompare)) {
                genselectlist(tree, regex, 0, t->getname().c_str(), 0, t);
                processed.add(strdup(buf));
            }
        }
    } else {
        bool proceed = true;
        if(regex) proceed = (bool) !regexec(regex, r, 0, 0, 0);
        
        if(proceed) {
            if(r = strchr(p, '/')) {
                strcpy(buf, p);
                buf[r-p] = 0;
                nfid = tree->addnode(foldid, conf.getcolor(cp_menuhl), 0, (string) " " + buf + " ");

                for(i = 0; i < count; i++) {
                    t = get(i);
                    r = t->getname().c_str()+offset;
                    nextlevel = r+strlen(buf)+1;

                    if(!strncmp(r, buf, strlen(buf)))
                    if(!processed.find(kgetword(1, nextlevel, "/", sub, 512), &stringcompare)) {
                        genselectlist(tree, regex, nfid, nextlevel, offset+strlen(buf)+1, t);
                        processed.add(strdup(sub));
                    }
                }
            } else {
                tree->addleaf(foldid, 0, ctemplate, (string) " " + p + " ");
            }
        }
    }
}

motortemplate *CMotorTemplateList::select(motortemplate *start = 0, regex_t *regex = 0) {
    int n, b;
    motortemplate *ret = 0;
    dialogbox db;

    db.setwindow(new textwindow(0, 0, DIALOG_WIDTH, DIALOG_HEIGHT,
        conf.getcolor(cp_menufr), TW_CENTERED,
        conf.getcolor(cp_menuhl), _(" Templates available ")));
    db.settree(new treeview(conf.getcolor(cp_menu),
        conf.getcolor(cp_menusel), conf.getcolor(cp_menu),
        conf.getcolor(cp_menu)));

    genselectlist(db.gettree(), regex);
    if(start) db.gettree()->setcur(start);

    if(!db.open(n, b, (void **) &ret)) ret = start;
    db.close();

    return ret;
}

